/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is Soyapi Mumba.
 *
 * Portions created by the Initial Developer are Copyright (C) 2005,2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var SWOService = {
    serviceName: "",
    
    onLoad: function() 
    {
        var serviceList = window.arguments[0];
        var serviceId = serviceList.selectedItem.value;
        this.serviceName = serviceList.selectedItem.label;
        var swPrefPane = document.getElementById("paneSWService");
        
        var serviceLabel = document.getElementById("searchwith-prefs-service-label");
        var prefLabel = swPrefPane.preferenceForElement(serviceLabel);
        prefLabel.setAttribute("name", "extensions.searchwith.service."+serviceId+".label");
        prefLabel.value = this.serviceName;
        prefLabel.updateElements();
        
        this.populateEngines();
    },
    
    populateEngines: function() {
        var serviceList = window.arguments[0];
        var serviceId = serviceList.selectedItem.value;
        var swEngines = SearchWith.getEngines();	
        var swPrefPane = document.getElementById("paneSWService");
        var swEngineList = document.getElementById("searchwith-prefs-new-service-engine");
        var currentService = new SWService(serviceId);
        var currentEngine = new SWEngine(currentService.getEngineId());
        
        var prefEngine = swPrefPane.preferenceForElement(swEngineList);
        prefEngine.setAttribute("name", "extensions.searchwith.service."+serviceId+".engine");
        prefEngine.updateElements();
    
        var mi;
        for (engine in swEngines) {
            var thisEngine = new SWEngine(swEngines[engine]);
            if (thisEngine.getName().trim().length < 1 || 
                swEngines[engine].trim().length < 1) {
                continue;
            }
            if ((thisEngine.getServiceId() == serviceId) || 
                (thisEngine.getServiceId() == "") || 
                (currentService.countEngines() == 0)) {
                mi = swEngineList.appendItem(thisEngine.getName(), swEngines[engine]);
                mi.setAttribute("label", thisEngine.getName());
                mi.setAttribute("value", swEngines[engine]);
                if (swEngines[engine] == currentService.getEngineId()) {
                    swEngineList.selectedItem = mi;
                    prefEngine.value = swEngines[engine];
                }
            }
        }
    },
    
    saveEngine: function() 
    {
        var serviceList = window.arguments[0];
        var swEngineList = document.getElementById("searchwith-prefs-new-service-engine");
        if (swEngineList.selectedItem.value.length <1) {
            serviceList.selectedItem.disabled = true;
        } else {
            serviceList.selectedItem.disabled = false;
        }
        return swEngineList.selectedItem.value;
    },
    
    saveName: function() 
    {
		var theServiceList = window.arguments[0];
        var serviceLabel = document.getElementById("searchwith-prefs-service-label");
		
		if (serviceLabel.value.length >0) {
			theServiceList.selectedItem.label = serviceLabel.value;
		}
        return serviceLabel.value;
    },
    
    acceptDialog: function() {
		var thisServiceList = window.arguments[0];
        var serviceText = document.getElementById("searchwith-prefs-service-label");
        if (serviceText.value.length < 1) {
            alert(SearchWith.getPropString("enter.service.name", "searchwith-strings"));
            return false;
        }
		thisServiceList.selectedItem.label = serviceText.value;
        return true;
    },
    
    cancelDialog: function() {
        var serviceText = document.getElementById("searchwith-prefs-service-label");
        var theServiceList = window.arguments[0];
		
		serviceText.value = this.serviceName;
		theServiceList.selectedItem.label = this.serviceName;
        return true;
    }

};



